/* interp.h - Alore interpreter

   Copyright (c) 2010 Jukka Lehtosalo

   Alore is licensed under the terms of the MIT license.  See the file
   LICENSE.txt in the distribution.
*/

#ifndef INTERP_H_INCL
#define INTERP_H_INCL

#include "debug_params.h"


typedef enum {
    EM_NO_MESSAGE,
    EM_NOT_CLASS_INSTANCE,
    EM_INDEX_OUT_OF_BOUNDS,
    EM_ARRAY_SIZES_DO_NOT_MATCH,
    EM_DIVISION_BY_ZERO,
    EM_TOO_MANY_RECURSIVE_CALLS
} AExceptionMessageId;


#define AErrorId(type, message) \
    ((type) | ((message) << 5))

#define AGetErrorTypeFromId(id) \
    ((id) & 0x1f)

#define AGetErrorMessageFromId(id) \
    ((id) >> 5)


#if !defined(__GNUC__) || defined(A_DEBUG) || defined(A_NO_GCC_EXTENSIONS)
#  define A_INITIALIZE_INTERPRETER
#  define A_BEGIN_INTERPRETER_LOOP for (;;) { 
#  define A_BEGIN_INTERPRETER_LOOP_2 switch (*ip) {
#  define A_OPCODE(name) case name:
#  define A_END_OPCODE break
#  define A_END_INTERPRETER_LOOP } }
#  define A_IP_REG
#  define A_STACK_REG
#else
#  include "gccinterp.h"
#endif


#endif
